/*
 * lib_i386.S
 *
 * Copyright 2002, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 * ֥롼饤֥꡼
 */


#define ASM_FILE


#include"segment.h"


.text


/*
 * void idle();
 * ɥ롼
 */
.globl idle
idle:
	hlt
	jmp		idle


/*
 * long long rdtsc()
 * ֤ : å
 */
.globl rdtsc
rdtsc:
	rdtsc
	ret


/*
 * void fpuSave(uint)
 */
.globl fpuSave
fpuSave:
	movl	4(%esp), %eax
	fnsave	(%eax)
	ret


/*
 * void fpuStore(uint)
 */
.globl fpuStore
fpuStore:
	movl	4(%esp), %eax
	frstor	(%eax)
	ret


/*
 * void clearTs()
 */
.globl clearTs
clearTs:
	movl	%cr0,%eax
	andl	$~0x8,%eax
	movl	%eax,%cr0
	ret


/*
 * void setTs()
 */
.globl setTs
setTs:
	movl	%cr0,%eax
	orl		$0x8,%eax
	movl	%eax,%cr0
	ret


// uint getFualtAddr()
.globl getFualtAddr
getFualtAddr:
	movl	%cr2,%eax	// եɥ쥹
	ret


/*
 * void *memcpy(void *dest,const void *src, size_t n);
 * Сåפʤԡ
 * P6ץåξ硢ɥ쥹8Хȶ256ХȰʾΥԡʤ®ǥԡ
 */
.globl memcpy
memcpy:
	pushl	%esi
	pushl	%edi
	movl	12(%esp),%edi
	movl	16(%esp),%esi
	cmpl	%esi,%edi
	je		1f

	/* Adjust alignment by 4bytes */
	xorl	%ecx,%ecx
	subl	%esi,%ecx
	andl	$0x3,%ecx
	cmpl	20(%esp),%ecx
	ja		2f
	movl	%ecx,%eax
	rep
	movsb

	/* Move by 4bytes */
	movl	20(%esp),%ecx
	subl	%eax,%ecx
	movl	%ecx,20(%esp)
	shrl	$2,%ecx
	rep
	movsl

	/* Move rest by bytes */
2:	movl	20(%esp),%ecx
	andl	$0x3,%ecx
	rep
	movsb

1:	movl	12(%esp),%eax
	popl	%edi
	popl	%esi
	ret


/*
 * void memCpyBack(void *dest,const void *src, size_t n);
 * Сåפ륳ԡ
 */
.globl memCpyBack
memCpyBack:
	pushl	%esi
	pushl	%edi
	movl	12(%esp),%edi
	movl	16(%esp),%esi
	movl	20(%esp),%ecx
	std

	addl	%ecx,%edi
	addl	%ecx,%esi
	decl	%edi
	decl	%esi
	rep
	movsb

	cld
	popl	%edi
	popl	%esi
	ret


/*
 * void *memset(void *dest,int c,size_t n);
 * P6ץåξ硢ɥ쥹8Хȶ256ХȰʾΥԡʤ®ǥԡ
 */
.globl memset
memset:
	pushl	%edi
	movl	8(%esp),%edi
	movl	12(%esp),%eax
	movl	16(%esp),%ecx
	orl		%ecx,%ecx
	je		1f

	/* Adjust alignment by 8bytes */
	xorl	%ecx,%ecx
	subl	%edi,%ecx
	andl	$0x7,%ecx
	cmpl	16(%esp),%ecx
	ja		2f
	movl	%ecx,%edx
	rep
	stosb

	/* Store by 4bytes */
	movb	%al,%ah
	movl	%eax,%ecx
	shll	$16,%eax
	orl		%ecx,%eax
	movl	16(%esp),%ecx
	subl	%edx,%ecx
	movl	%ecx,16(%esp)
	shrl	$2,%ecx
	rep
	stosl

	/* Store rest by bytes */
2:	movl	16(%esp),%ecx
	andl	$0x3,%ecx
	rep
	stosb

1:	movl	12(%esp),%eax
	popl	%edi
	ret
