/*
 * sys/systm.h
 */


#ifndef sys_systm_h
#define sys_systm_h


#include <sys/cdefs.h>
#include <sys/callout.h>
#include <sys/proc.h>
#include <lib.h>
#include <lock.h>
#include <machine/stdarg.h>


#ifdef KERNEL


struct callout_handle;


typedef void timeout_t __P((void *));	/* timeout function type */


#define bootverbose 1		/* nonzero to print verbose messages */

#define uprintf printf
#define bzero(buf, len) memset(buf, 0, len)
#define splhigh enterCli
#define splbio enterCli
#define splx exitCli

extern inline int copyin __P((const void *udaddr, void *kaddr, size_t len))
{
	memcpy(kaddr, udaddr, len);
	return 0;
}
extern void	bcopy __P((const void *from, void *to, size_t len));
extern int	seltrue __P((dev_t dev, int which, struct proc *p));
extern int	printf __P((const char *, ...));
extern int	vprintf __P((const char *, va_list));
extern int	kvprintf __P((char const *, void (*)(int, void*), void *, int, va_list));
extern int	snprintf __P((char *, size_t, const char *, ...));
extern struct	callout_handle timeout __P((timeout_t *, void *, int));
extern void	untimeout __P((timeout_t *, void *, struct callout_handle));
extern void	callout_handle_init __P((struct callout_handle *));
extern int	tsleep __P((void *chan, int pri, const char *wmesg, int timo));


#endif


#endif
